#include<iostream>
#include<cstdio>
#include "bitmap.h"
#include<get.h>
#include<cmath>                                       //Inclusion of header files required
#include "rect.h"
#include "ezwin.h"
#include <ctime>
#include <sstream>
#include <cstdlib>


SimpleWindow W1("Mafia",21.78,16.0,Position(0.0,0.0));

BitMap Back(W1);
BitMap Background(W1);
BitMap Credits(W1);
BitMap CreditsPage(W1);
BitMap Instructions(W1);
BitMap InstructionsPage(W1);
BitMap Hard(W1);
BitMap Easy(W1);
BitMap Normal(W1);
BitMap StartGame(W1);
BitMap StartGamePage(W1);
BitMap HighScores(W1);
BitMap HighScoresPage(W1);
BitMap NewGame(W1);
BitMap Exit(W1);
BitMap Greenland(W1);
BitMap L1(W1);
BitMap R1(W1);
BitMap F1(W1);
BitMap B1(W1);
BitMap L2(W1);
BitMap R2(W1);
BitMap F2(W1);
BitMap B2(W1);
BitMap LG1(W1);
BitMap BG1(W1);
BitMap RG1(W1);
BitMap FG1(W1);
BitMap LG2(W1);
BitMap BG2(W1);
BitMap RG2(W1);
BitMap FG2(W1);
BitMap LL1(W1);
BitMap RL1(W1);
BitMap FL1(W1);
BitMap BL1(W1);
BitMap LL2(W1);
BitMap RL2(W1);
BitMap FL2(W1);
BitMap BL2(W1);
BitMap LGL1(W1);
BitMap BGL1(W1);
BitMap RGL1(W1);
BitMap FGL1(W1);
BitMap LGL2(W1);
BitMap BGL2(W1);
BitMap RGL2(W1);
BitMap FGL2(W1);
BitMap LR1(W1);
BitMap RR1(W1);
BitMap FR1(W1);
BitMap BR1(W1);
BitMap LR2(W1);
BitMap RR2(W1);
BitMap FR2(W1);
BitMap BR2(W1);
BitMap LGR1(W1);
BitMap BGR1(W1);
BitMap RGR1(W1);
BitMap FGR1(W1);
BitMap LGR2(W1);
BitMap BGR2(W1);
BitMap RGR2(W1);
BitMap FGR2(W1);
BitMap BackupPlayer(W1);
BitMap Hud1(W1);
BitMap Hud2(W1);
BitMap Bullet1(W1);
BitMap Bullet2(W1);
BitMap Bullet3(W1);
BitMap Bullet4(W1);
BitMap Bullet5(W1);
BitMap Bullet6(W1);
BitMap Bullet7(W1);
BitMap Bullet8(W1);
BitMap BackUpBullet1(W1);
BitMap BackUpBullet2(W1); 
BitMap Bomb(W1);
BitMap BackUpBomb(W1);
BitMap BackUpLife(W1);
BitMap One(W1);
BitMap Two(W1);
BitMap Three(W1);
BitMap BackUpNumber(W1);
BitMap Target1(W1);
BitMap Target2(W1);
BitMap BackUpTarget(W1);
BitMap TargetImage1(W1);
BitMap TargetImage2(W1);
BitMap BackUpTargetImage(W1);
BitMap Ex1(W1);
BitMap Ex2(W1);
BitMap Ex3(W1);
BitMap Ex4(W1);
BitMap Ex5(W1);
BitMap Ex6(W1);
BitMap Ex7(W1);
BitMap Ex8(W1);
BitMap Ex9(W1);
BitMap BackUpBlast(W1);

int n,z=1,x=1,r,s=0,y=3,player1bomb=0,player2bomb=0,player1score=0,player2score=0,move1=0,move2=0;    
float i=0.02,j=0.2,k=7.0,q=5.0,m,u,v,a=15.0,b=7.0;
char c='e',d;
clock_t t1,t0;

void ClearScreen(){
    Back.Erase();
    Background.Erase();
    Credits.Erase();
    CreditsPage.Erase();
    Instructions.Erase();
    InstructionsPage.Erase();
    Hard.Erase();
    Easy.Erase();
    Normal.Erase();
    StartGame.Erase();
    StartGamePage.Erase();
    HighScores.Erase();
    HighScoresPage.Erase();
    NewGame.Erase();
    Exit.Erase();
    Greenland.Erase();
}
 

int timer(float millisec){
    clock_t endwait=clock()+CLOCKS_PER_SEC*(millisec/32);
    while(endwait>clock());
    return 0;
}


void Explosion(){
    if(player1bomb)
    {
     BackUpBomb.SetPosition(Position(20.54,1.8));
     BackUpBomb.Draw();      

     BackUpTarget.SetPosition(Position(19.89,2.5));
     BackUpTarget.Draw();
  
     Ex1.SetPosition(Position(20.0,2.5));
     Ex2.SetPosition(Position(20.0,2.5));
     Ex3.SetPosition(Position(20.0,2.5));
     Ex4.SetPosition(Position(20.0,2.5));
     Ex5.SetPosition(Position(20.0,2.5));
     Ex6.SetPosition(Position(20.0,2.5));
     Ex7.SetPosition(Position(20.0,2.5));
     Ex8.SetPosition(Position(20.0,2.5));
     Ex9.SetPosition(Position(20.0,2.5)); 

     Ex1.Draw();
     timer(4);
     Ex2.Draw();
     timer(4);
     Ex3.Draw();
     timer(4);
     Ex4.Draw();
     timer(4);
     Ex5.Draw();
     timer(4);
     Ex6.Draw();
     timer(4);
     Ex7.Draw();
     timer(4);
     Ex8.Draw();
     timer(4);
     Ex9.Draw();
     timer(4);
    }
    else
    {
     BackUpBomb.SetPosition(Position(0.7,1.8));
     BackUpBomb.Draw();      

     BackUpTarget.SetPosition(Position(0.2,2.5));
     BackUpTarget.Draw();
  
     Ex1.SetPosition(Position(0.2,2.5));
     Ex2.SetPosition(Position(0.2,2.5));
     Ex3.SetPosition(Position(0.2,2.5));
     Ex4.SetPosition(Position(0.2,2.5));
     Ex5.SetPosition(Position(0.2,2.5));
     Ex6.SetPosition(Position(0.2,2.5));
     Ex7.SetPosition(Position(0.2,2.5));
     Ex8.SetPosition(Position(0.2,2.5));
     Ex9.SetPosition(Position(0.2,2.5)); 

     Ex1.Draw();
     timer(2);
     Ex2.Draw();
     timer(2);
     Ex3.Draw();
     timer(2);
     Ex4.Draw();
     timer(2);
     Ex5.Draw();
     timer(2);
     Ex6.Draw();
     timer(2);
     Ex7.Draw();
     timer(2);
     Ex8.Draw();
     timer(2);
     Ex9.Draw();
     timer(2);
    }
   }
     


int Timer(){
    One.SetPosition(Position(10.4,0.2));
    Two.SetPosition(Position(10.4,0.2));
    Three.SetPosition(Position(10.4,0.2));
    
    Three.Draw();
    timer(30);
    Two.Draw();  
    timer(30);
    One.Draw();
    timer(30);

    BackUpNumber.SetPosition(Position(10.4,0.2));
    BackUpNumber.Draw();
    
    Explosion(); 

    if(player1bomb)
    {
     Target2.SetPosition(Position(19.89,2.5));
     Target2.Draw();
  
     TargetImage2.SetPosition(Position(20.04,1.4));
     TargetImage2.Draw();

     Bomb.SetPosition(Position(10.5,7.5));
     Bomb.Draw();

     player1bomb=0;
 
     player1score++;
     cout<<"\n"<<"PLAYER 1 SCORE ="<<player1score<<"\n";
    }
    else
    {
     Target1.SetPosition(Position(0.2,2.5));
     Target1.Draw();    

     TargetImage1.SetPosition(Position(0.35,1.4));
     TargetImage1.Draw();    

     Bomb.SetPosition(Position(10.5,7.5));
     Bomb.Draw();

     player2bomb=0;
 
     player2score++;
    }
   return 1;
   }


int Bullet(){
 
           BackUpBullet1.SetPosition(Position(u,v));
           BackUpBullet1.Draw();             
 cout<<"\n"<<"hello"<<"\n";
           Bullet1.SetPosition(Position(u+0.02,v));
           Bullet1.Draw();
           
           u=u+0.02;
           return 1;
        }













void MainScreen()
{
  n=1; 
  m=3.65;

  Background.SetPosition(Position(0.0,0.0));
  Background.Draw();

  RectangleShape R(W1,4.66,m,Red,5.5,1.5);
  R.Draw();
                
  NewGame.SetPosition(Position(2.0,3.0));
  NewGame.Draw();
           
  Instructions.SetPosition(Position(2.0,5.0));
  Instructions.Draw();

  Credits.SetPosition(Position(2.0,7.0));
  Credits.Draw();
 	    
  HighScores.SetPosition(Position(2.0,9.0));
  HighScores.Draw(); 

  Exit.SetPosition(Position(2.0,11.0));
  Exit.Draw();
}



int AI(){
        srand(time(0));

         r=rand()%4+1;
         if((((a<=8.7 || (a>10.9 && a<=20.0)) && b<8.2 && b>5.8) || (a<=20.0 && ((b>=4.0 && b<=5.81) || b>=8.19)) || (a<=17.9 && b<4)) && r==1)     // Right
         {          
        
           BackupPlayer.SetPosition(Position(a,b));
           BackupPlayer.Draw();
          
         if(player2bomb)
          {
          if(move2==0)
          {
           RL2.SetPosition(Position(a+i,b));
           RL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           R2.SetPosition(Position(a+i,b));
           R2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           RR2.SetPosition(Position(a+i,b));
           RR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           R2.SetPosition(Position(a+i,b));
           R2.Draw();
           move2=0;
          }
         }
         else
         {
          if(move2==0)
          {
           RGL2.SetPosition(Position(a+i,b));
           RGL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           RG2.SetPosition(Position(a+i,b));
           RG2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           RGR2.SetPosition(Position(a+i,b));
           RGR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           RG2.SetPosition(Position(a+i,b));
           RG2.Draw();
           move2=0;
          }
         }
           a+=i;
           y=1;
        
         }
         else if(((a>=0.2 && ((b>=4.0 && b<=5.81) || b>=8.19)) || (a>=2.2 && b<4) || ((a>=11 || (a<=8.8 && a>=0.2)) && b<8.2 && b>5.8)) && r==2)    // Left
         {          
         
           BackupPlayer.SetPosition(Position(a,b));
           BackupPlayer.Draw();
          
         if(player2bomb)
          {
          if(move2==0)
          {
           LL2.SetPosition(Position(a-i,b));
           LL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           L2.SetPosition(Position(a-i,b));
           L2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           LR2.SetPosition(Position(a-i,b));
           LR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           L2.SetPosition(Position(a-i,b));
           L2.Draw();
           move2=0;
          }
         }
         else
         {
          if(move2==0)
          {
           LGL2.SetPosition(Position(a-i,b));
           LGL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           LG2.SetPosition(Position(a-i,b));
           LG2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           LGR2.SetPosition(Position(a-i,b));
           LGR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           LG2.SetPosition(Position(a-i,b));
           LG2.Draw();
           move2=0;
          }
         }
           a-=i;
           y=3;
          
         }
         else if(((a>8.8 && a<11 && ((b>=8.19 && b<=13.5) || b<=5.8)) || ((a<=8.8 || a>=10.9) && b<=13.5)) && r==3)                                 // Down
         {          
          
           BackupPlayer.SetPosition(Position(a,b));
           BackupPlayer.Draw();
          
         if(player2bomb)
          {
          if(move2==0)
          {
           FL2.SetPosition(Position(a,b+i));
           FL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           F2.SetPosition(Position(a,b+i));
           F2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           FR2.SetPosition(Position(a,b+i));
           FR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           F2.SetPosition(Position(a,b+i));
           F2.Draw();
           move2=0;
          }
         }
         else
         {
          if(move2==0)
          {
           FGL2.SetPosition(Position(a,b+i));
           FGL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           FG2.SetPosition(Position(a,b+i));
           FG2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           FGR2.SetPosition(Position(a,b+i));
           FGR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           FG2.SetPosition(Position(a,b+i));
           FG2.Draw();
           move2=0;
          }
         }
           b+=i;
           y=4;
        
         }
         else if(((a>8.8 && a<11 && (b>=8.2 || (b<=5.81 && b>=1.5))) || (b>=1.5 && ((a>=2.0 && a<=8.8) || (a>=10.9 && a<=18.0))) || (b>=4.2 && (a<2 || a>18))) && r==4)
         {          
        
           BackupPlayer.SetPosition(Position(a,b));
           BackupPlayer.Draw();
         if(player2bomb)
          {
          if(move2==0)
          {
           BL2.SetPosition(Position(a,b-i));
           BL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           B2.SetPosition(Position(a,b-i));
           B2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           BR2.SetPosition(Position(a,b-i));
           BR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           B2.SetPosition(Position(a,b-i));
           B2.Draw();
           move2=0;
          }
         }
         else
         {
          if(move2==0)
          {
           BGL2.SetPosition(Position(a,b-i));
           BGL2.Draw();
           move2=1;
          }
          else if(move2==1)
          {
           BG2.SetPosition(Position(a,b-i));
           BG2.Draw();
           move2=2;
          }
          else if(move2==2)
          {
           BGR2.SetPosition(Position(a,b-i));
           BGR2.Draw();
           move2=3;
          }
          else if(move2==3)
          {
           BG2.SetPosition(Position(a,b-i));
           BG2.Draw();
           move2=0;
          }
         }
           b-=i;
           y=2;
        
         }
        
           return 1;
 }


int T1(){
        AI();
        return 1;
        }


int ApiMain(){ 
      
   W1.Open();
   Back.Load("BACK.xpm");
   Background.Load("Background.xpm");
   CreditsPage.Load("Credits.xpm"); 
   Credits.Load("CREDITS.xpm");
   StartGamePage.Load("StartGame.xpm");
   Easy.Load("EASY.xpm");
   Exit.Load("EXIT.xpm");
   Hard.Load("HARD.xpm");
   HighScoresPage.Load("High_Scores.xpm");
   HighScores.Load("HIGH_SCORES.xpm");
   InstructionsPage.Load("Instructions.xpm");
   Instructions.Load("INSTRUCTIONS.xpm");
   NewGame.Load("NEW_GAME.xpm");
   Normal.Load("NORMAL.xpm");
   StartGame.Load("START_GAME.xpm");
   Greenland.Load("Greenland.xpm");
   L1.Load("L1.xpm");
   R1.Load("R1.xpm");
   B1.Load("B1.xpm");
   F1.Load("F1.xpm");
   L2.Load("L2.xpm");
   R2.Load("R2.xpm");
   B2.Load("B2.xpm");
   F2.Load("F2.xpm");
   LG1.Load("LG1.xpm");
   RG1.Load("RG1.xpm");    
   BG1.Load("BG1.xpm");
   FG1.Load("FG1.xpm");
   LG2.Load("LG2.xpm");
   RG2.Load("RG2.xpm");    
   BG2.Load("BG2.xpm");
   FG2.Load("FG2.xpm");
   LL1.Load("LL1.xpm");
   RL1.Load("RL1.xpm");
   BL1.Load("BL1.xpm");
   FL1.Load("FL1.xpm");
   LL2.Load("LL2.xpm");
   RL2.Load("RL2.xpm");
   BL2.Load("BL2.xpm");
   FL2.Load("FL2.xpm");
   LGL1.Load("LGL1.xpm");
   RGL1.Load("RGL1.xpm");    
   BGL1.Load("BGL1.xpm");
   FGL1.Load("FGL1.xpm");
   LGL2.Load("LGL2.xpm");
   RGL2.Load("RGL2.xpm");    
   BGL2.Load("BGL2.xpm");
   FGL2.Load("FGL2.xpm");
   LR1.Load("LR1.xpm");
   RR1.Load("RR1.xpm");
   BR1.Load("BR1.xpm");
   FR1.Load("FR1.xpm");
   LR2.Load("L2.xpm");
   RR2.Load("RR2.xpm");
   BR2.Load("BR2.xpm");
   FR2.Load("FR2.xpm");
   LGR1.Load("LGR1.xpm");
   RGR1.Load("RGR1.xpm");    
   BGR1.Load("BGR1.xpm");
   FGR1.Load("FGR1.xpm");
   LGR2.Load("LGR2.xpm");
   RGR2.Load("RGR2.xpm");    
   BGR2.Load("BGR2.xpm");
   FGR2.Load("FGR2.xpm");
   BackupPlayer.Load("BackupPlayer.xpm");
   Hud1.Load("Player1hud.xpm");
   Hud2.Load("Player2hud.xpm");
   Bullet1.Load("Bullet1.xpm");
   Bullet2.Load("Bullet2.xpm");
   Bullet3.Load("Bullet3.xpm");
   Bullet4.Load("Bullet4.xpm");
   Bullet5.Load("Bullet5.xpm");
   Bullet6.Load("Bullet6.xpm");
   Bullet7.Load("Bullet7.xpm");
   Bullet8.Load("Bullet8.xpm");
   BackUpBullet1.Load("BackUpBullet1.xpm");
   BackUpBullet2.Load("BackUpBullet2.xpm");
   Target1.Load("Target1.xpm");
   Target2.Load("Target2.xpm");
   BackUpTarget.Load("BackUpTarget.xpm");
   TargetImage1.Load("TargetImage1.xpm");
   TargetImage2.Load("TargetImage2.xpm");
   BackUpTargetImage.Load("BackUpTargetImage.xpm"); 
   Ex1.Load("ex1.xpm");
   Ex2.Load("ex2.xpm");
   Ex3.Load("ex3.xpm");
   Ex4.Load("ex4.xpm");
   Ex5.Load("ex5.xpm");
   Ex6.Load("ex6.xpm");
   Ex7.Load("ex7.xpm");
   Ex8.Load("ex8.xpm");
   Ex9.Load("ex9.xpm");
   BackUpBlast.Load("BackUpBlast.xpm");
   Bomb.Load("Bomb.xpm");
   BackUpBomb.Load("BackUpBomb.xpm");
   One.Load("One.xpm");
   Two.Load("Two.xpm");
   Three.Load("Three.xpm");
   BackUpNumber.Load("BackUpNumber.xpm");
   
 

   MainScreen();

   while(z==1 || z==3)
   {
    d=getch();
    z=1;

    if((d=='b' || d=='B') && n<5)
    {
     Background.SetPosition(Position(0.0,0.0));
     Background.Draw();

     RectangleShape R1(W1,4.66,m+2.0,Red,5.5,1.5);
     R1.Draw();
                
     NewGame.SetPosition(Position(2.0,3.0));
     NewGame.Draw();
           
     Instructions.SetPosition(Position(2.0,5.0));
     Instructions.Draw();

     Credits.SetPosition(Position(2.0,7.0));
     Credits.Draw();
 	    
     HighScores.SetPosition(Position(2.0,9.0));
     HighScores.Draw(); 

     Exit.SetPosition(Position(2.0,11.0));
     Exit.Draw();
  
     m+=2.0;
     n++;
    }
    else if((d=='a' || d=='A') && n>1)
    {
     Background.SetPosition(Position(0.0,0.0));
     Background.Draw();

     RectangleShape R2(W1,4.66,m-2.0,Red,5.5,1.5);
     R2.Draw();
                
     NewGame.SetPosition(Position(2.0,3.0));
     NewGame.Draw();
           
     Instructions.SetPosition(Position(2.0,5.0));
     Instructions.Draw();

     Credits.SetPosition(Position(2.0,7.0));
     Credits.Draw();
 	    
     HighScores.SetPosition(Position(2.0,9.0));
     HighScores.Draw(); 

     Exit.SetPosition(Position(2.0,11.0));
     Exit.Draw();
  
     m-=2.0;
     n--;
    }
    else if(d==10)
    {
     switch(n){
      
     case 1:{    

     m=6.65;
     n=6;
     
     StartGamePage.SetPosition(Position(0.0,0.0));
     StartGamePage.Draw();

     RectangleShape R3(W1,4.66,m,Red,5.5,1.5);
     R3.Draw();
 
     StartGame.SetPosition(Position(2.0,6.0));
     StartGame.Draw();

     Back.SetPosition(Position(2.0,9.0));
     Back.Draw();

    while(z==1)
    {      
     d=getch();
     
    if((d=='b' || d=='B') && n<7)
    {
     StartGamePage.SetPosition(Position(0.0,0.0));
     StartGamePage.Draw();

     RectangleShape R4(W1,4.66,m+3.0,Red,5.5,1.5);
     R4.Draw();

     StartGame.SetPosition(Position(2.0,6.0));
     StartGame.Draw();

     Back.SetPosition(Position(2.0,9.0));
     Back.Draw();    
   
     m+=3.0;
     n++;
    }
    else if((d=='a' || d=='A') && n>6)
    {
     StartGamePage.SetPosition(Position(0.0,0.0));
     StartGamePage.Draw();

     RectangleShape R5(W1,4.66,m-3,Red,5.5,1.5);
     R5.Draw();
 
     StartGame.SetPosition(Position(2.0,6.0));
     StartGame.Draw();
    
     Back.SetPosition(Position(2.0,9.0));
     Back.Draw();

     m-=3.0;
     n--;
    }
  
    else if(d==10)
    {
     switch(n){
       
     case 6:z=2;
       break;
 
     case 7:
      {
       z=3;
       MainScreen();
      }  
     }
    }   
  }break;
}   
     
     case 2:{
   
     InstructionsPage.SetPosition(Position(0.0,0.0));
     InstructionsPage.Draw();

     RectangleShape R16(W1,4.66,13.65,Red,5.5,1.5);
     R16.Draw();
                
     Back.SetPosition(Position(2.0,13.0));
     Back.Draw(); 
  
    while(z==1)
    {
     d=getch();
     
    if(d==10)
    {
     z=3;
     MainScreen();
    }
   }
  
     break;
 }


     case 3:{
 
     CreditsPage.SetPosition(Position(0.0,0.0));
     CreditsPage.Draw();
    
     RectangleShape R17(W1,4.66,13.65,Red,5.5,1.5);
     R17.Draw();
            
     Back.SetPosition(Position(2.0,13.0));
     Back.Draw();
    
    while(z==1)
    {
     d=getch();
     
    if(d==10)
    {
     z=3;
     MainScreen();
    }
   }
     
    break;
 }


     case 4:{
 
     HighScoresPage.SetPosition(Position(0.0,0.0));
     HighScoresPage.Draw();
    
     RectangleShape R18(W1,4.66,13.65,Red,5.5,1.5);
     R18.Draw();
            
     Back.SetPosition(Position(2.0,13.0));
     Back.Draw();           
    
    while(z==1)
    {
     d=getch();
     
    if(d==10)
    {
     z=3;
     MainScreen();
    }
   }
     
    break;
 }


     case 5:
     {
      W1.Close();
      return 2;
     } 
    }
   } 
 }   
    
     

     ClearScreen();       

     Greenland.SetPosition(Position(0.0,0.0));
     Greenland.Draw();

     Hud1.SetPosition(Position(0.0,0.0));
     Hud1.Draw();
    
     Hud2.SetPosition(Position(16.45,0.0));
     Hud2.Draw();

     RG1.SetPosition(Position(q,k));
     RG1.Draw();
   
     LG2.SetPosition(Position(a,b));
     LG2.Draw();

     Bomb.SetPosition(Position(10.5,7.5));
     Bomb.Draw();
 
     Target1.SetPosition(Position(0.2,2.5));
     Target1.Draw();  

     Target2.SetPosition(Position(19.89,2.5));
     Target2.Draw();      

     TargetImage1.SetPosition(Position(0.35,1.4));
     TargetImage1.Draw();    
  
     TargetImage2.SetPosition(Position(20.04,1.4));
     TargetImage2.Draw();  
   

     while(c!='q' && c!='Q')
     {
       c=getch();   
   
       while(((q>8.8 && q<11 && (k>=8.2 || (k<=5.81 && k>=1.5))) || (k>=1.5 && ((q>=2.0 && q<=8.8) || (q>=10.9 && q<=18.0))) || (k>=4.2 && (q<2 || q>18))) &&(c=='a' || c=='A'))                                                                                                                                            //UP
       {                                                                                                                                            
         BackupPlayer.SetPosition(Position(q,k));
         BackupPlayer.Draw();
         if(player1bomb)
         {
          if(move1==0)
          {
           BL1.SetPosition(Position(q,k-j));
           BL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           B1.SetPosition(Position(q,k-j));
           B1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           BR1.SetPosition(Position(q,k-j));
           BR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           B1.SetPosition(Position(q,k-j));
           B1.Draw();
           move1=0;
          }
         }
         else
         {
          if(move1==0)
          {
           BGL1.SetPosition(Position(q,k-j));
           BGL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           BG1.SetPosition(Position(q,k-j));
           BG1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           BGR1.SetPosition(Position(q,k-j));
           BGR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           BG1.SetPosition(Position(q,k-j));
           BG1.Draw();
           move1=0;
          }
         }
         k-=j;
         AI();
         c=getch();
         x=2;
         printf("%f\n%f\n%d\n",q,k,y);
       }
       AI();
       while(((q>=0.2 && ((k>=4.0 && k<=5.81) || k>=8.19)) || (q>=2.2 && k<4) || ((q>=11 || (q<=8.8 && q>=0.2)) && k<8.2 && k>5.8)) && (c=='d' || c=='D'))      //LEFT
       {
         BackupPlayer.SetPosition(Position(q,k));
         BackupPlayer.Draw();
         if(player1bomb)
         {
          if(move1==0)
          {
           LL1.SetPosition(Position(q-j,k));
           LL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           L1.SetPosition(Position(q-j,k));
           L1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           LR1.SetPosition(Position(q-j,k));
           LR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           L1.SetPosition(Position(q-j,k));
           L1.Draw();
           move1=0;
          }
         }
         else
         {
          if(move1==0)
          {
           LGL1.SetPosition(Position(q-j,k));
           LGL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           LG1.SetPosition(Position(q-j,k));
           LG1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           LGR1.SetPosition(Position(q-j,k));
           LGR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           LG1.SetPosition(Position(q-j,k));
           LG1.Draw();
           move1=0;
          }
         }
         q-=j;
         AI();
         c=getch();
         x=3;
         printf("%f\n%f\n%d\n",q,k,y);
       }
        AI();
       while(((q>8.8 && q<11 && ((k>=8.19 && k<=13.5) || k<=5.8)) || ((q<=8.8 || q>=10.9) && k<=13.5)) && (c=='b' || c=='B'))                                    //DOWN
       { 
         BackupPlayer.SetPosition(Position(q,k));
         BackupPlayer.Draw();
         if(player1bomb)
         {
          if(move1==0)
          {
           FL1.SetPosition(Position(q,k+j));
           FL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           F1.SetPosition(Position(q,k+j));
           F1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           FR1.SetPosition(Position(q,k+j));
           FR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           F1.SetPosition(Position(q,k+j));
           F1.Draw();
           move1=0;
          }
         }
         else
         {
          if(move1==0)
          {
           FGL1.SetPosition(Position(q,k+j));
           FGL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           FG1.SetPosition(Position(q,k+j));
           FG1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           FGR1.SetPosition(Position(q,k+j));
           FGR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           FG1.SetPosition(Position(q,k+j));
           FG1.Draw();
           move1=0;
          }
         }
         k+=j;
         AI();
         c=getch();
         x=4;
         printf("%f\n%f\n%d\n",q,k,y);      
       }
        AI();
       while((((q<=8.7 || (q>10.9 && q<=20.0)) && k<8.2 && k>5.8) || (q<=20.0 && ((k>=4.0 && k<=5.81) || k>=8.19)) || (q<=17.9 && k<4)) && (c=='c' || c=='C'))   //RIGHT
       {
         BackupPlayer.SetPosition(Position(q,k));
         BackupPlayer.Draw();
         if(player1bomb)
         {
          if(move1==0)
          {
           RL1.SetPosition(Position(q+j,k));
           RL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           R1.SetPosition(Position(q+j,k));
           R1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           RR1.SetPosition(Position(q+j,k));
           RR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           R1.SetPosition(Position(q+j,k));
           R1.Draw();
           move1=0;
          }
         }
         else
         {
          if(move1==0)
          {
           RGL1.SetPosition(Position(q+j,k));
           RGL1.Draw();
           move1=1;
          }
          else if(move1==1)
          {
           RG1.SetPosition(Position(q+j,k));
           RG1.Draw();
           move1=2;
          }
          else if(move1==2)
          {
           RGR1.SetPosition(Position(q+j,k));
           RGR1.Draw();
           move1=3;
          }
          else if(move1==3)
          {
           RG1.SetPosition(Position(q+j,k));
           RG1.Draw();
           move1=0;
          }
         } 
         q+=j;
         AI();
         c=getch();
         x=1;
         printf("%f\n%f\n%d\n",q,k,y);
       }
       AI();
       
       while((c=='h' || c=='H') && !player1bomb && !player2bomb && (((q>8.79 && q<11.01) && (abs(k-5.8)<0.001 || abs(k-8.2)<0.001)) || ((k>5.79 && k<8.21) && (abs(q-8.8)<0.001 || abs(q-11)<0.001))))
       {
         BackUpBomb.SetPosition(Position(10.5,7.5));
         BackUpBomb.Draw(); 
         player1bomb=1;
       }      
        
       while((c=='h' || c=='H') && player1bomb && ((q>17.99 && abs(k-4)<0.001) || (k<4.01 && abs(q-18)<0.001)))
       {
         BackUpTargetImage.SetPosition(Position(20.04,1.4));
         BackUpTargetImage.Draw();  

         Bomb.SetPosition(Position(20.54,1.8));
         Bomb.Draw();
 
         Timer();
       }

     AI();
     while((c=='f' || c=='F') && !player1bomb)
       {
         if((x==1 && (((q<8.59 || q>11) && k>6.61 && k<7.39) || (k<3.4 && abs(18-q)>=0.2) || (k>=3.4 && k<=6.61) || k>=7.39)))
         {
          u=q+1.7;
          v=k+0.7; 
         
         Bullet1.SetPosition(Position(u,v));
         Bullet1.Draw();
 
         W1.SetTimerCallback(Bullet);
         W1.StartTimer(10);
        
         cout<<"\n"<<"hi"<<"\n";
         cout<<"\n"<<"thank you"<<"\n";    
         BackUpBullet1.SetPosition(Position(u,v));
         BackUpBullet1.Draw();
         
         c=getch();
         }
         else if(x==1 && ((q>=8.59 && q<=11 && k>6.6 && k<7.4) || (abs(18-q)<0.2 && k<3.4)))
           c=getch();
  
         else if(x==2 && (((q>=1.2 && q<=9.6) || (q>=10.19 && q<=19)) || (q>9.6 && q<10.2 && (k>=8.6 || k<=6)) || ((q<1.2 || q>19) && k>=4.6)))
         {
          u=q+0.7;
          v=k-0.32; 
         
         Bullet4.SetPosition(Position(u,v));
         Bullet4.Draw();

         W1.SetTimerCallback(Bullet);
         W1.StartTimer(100); 
 
         BackUpBullet2.SetPosition(Position(u,v));
         BackUpBullet2.Draw();
           
         c=getch();
         }
         else if(x==2 && ((q>9.6 && q<10.2 && k<8.6 && k>6) || ((q<1.2 || q>19) && k<4.6)))
           c=getch();
         
         else if(x==3 && (((q<8.9 || q>=11.4) && k>6.61 && k<7.39) || (k<3.4 && q>=2.4) || ((k>=3.4 && k<=6.61) || k>=7.39)))
         {
          u=q-0.3;
          v=k+0.7; 
       
         Bullet2.SetPosition(Position(u,v));
         Bullet2.Draw();

         W1.SetTimerCallback(Bullet);
         W1.StartTimer(100);
 
         BackUpBullet1.SetPosition(Position(u,v));
         BackUpBullet1.Draw(); 
           
         c=getch();
         }
         else if(x==3 && ((q>8.9 && q<11.4 && k>6.6 && k<7.4) || (q<2.4 && k<3.4)))
           c=getch();
         
         else if(x==4 && ((q<=9.6 || q>=10.19) || (q>9.6 && q<10.19 && (k<=5.2 || k>7.8)))) 
         {
          u=q+0.7;
          v=k+1.7; 
         
         Bullet3.SetPosition(Position(u,v));
         Bullet3.Draw();

         W1.SetTimerCallback(Bullet);
         W1.StartTimer(100);
 
         BackUpBullet2.SetPosition(Position(u,v));
         BackUpBullet2.Draw();
          
         c=getch(); 
         }
         else if(x==4 && (q>9.6 && q<10.19 && k>5.2 && k<=7.8))
          c=getch();
   }
}     W1.Close();
  
            

     return 0;      
}

 












